part of mdlcomponents;

@Component(
	selector: 'material-button',
	directives: const [NgIf,NgFor,NgClass],
	templateUrl: 'src/components/MaterialButton.html')

class MaterialButton {

	bool disabled = false;
	
	bool _raised = false;
	bool _fab = false;
	bool _minifab = false;
	bool _icon = false;
	bool _colored = false;
	bool _primary = true;
	bool _accent = false;
	bool _ripple = false;
	
	String _text = "Hello World!";

	Map<String,bool> buttonClasses;

    MaterialButton(){
    buttonClasses =  {'mdl-button':true,'mdl-js-button':true,'mdl-button--raised':_raised,'mdl-button--fab':_fab,'mdl-button--mini-fab':_minifab,'mdl-button--icon':_icon,'mdl-button--icon':_colored,'mdl-button--primary':_primary,'mdl-button--accent':_accent,'mdl-js-ripple-effect':_ripple};
    }

    /// Disable button.
    void disable() {
        disabled = true;
    }

    /// Enable button.
    void enable() {
        disabled = false;
    }

    
    void set enabled(final bool _enabled) => _enabled ? enable() : disable();
    bool get enabled => !disabled;

    void set value(final String value) {
        if(value != null) {
            _text = value;
        }
    }

    String get value => _text;

	bool get raised => _raised;
	bool get fab => _fab;
	bool get minifab => _minifab;
	bool get icon => _icon;
	bool get colored => _colored;
	bool get primary => _primary;
	bool get accent => _accent;
	bool get ripple => _ripple;

	void set raised(bool value) { _raised = value; buttonClasses['mdl-button--raised'] = _raised;}
	void set fab(bool value) { _fab = value; buttonClasses['mdl-button--fab'] = _fab;}
	void set minifab(bool value) { _minifab = value; buttonClasses['mdl-button--mini-fab'] = _minifab;}
	void set icon(bool value) { _icon = value; buttonClasses['mdl-button--icon'] = _icon;}
	void set colored(bool value) { _colored = value; buttonClasses['mdl-button--colored'] = _colored;}
	void set primary(bool value) { _primary = value; buttonClasses['mdl-button--primary'] = _primary;}
	void set accent(bool value) { _accent = value; buttonClasses['mdl-button--accent'] = _accent;}
	void set ripple(bool value) { _ripple = value; buttonClasses['mdl-js-ripple-effect'] = _ripple;}


}

