part of mdlcomponents;


@Directive(
	selector: '[floatinglabel]')
class FloatingLabel{}


@Component(
	selector: 'material-textfield',
	directives: const [NgIf,NgFor,NgClass,FloatingLabel],
	templateUrl: 'src/components/MaterialTextField.html')

class MaterialTextField {
	
	bool _disabled;
	bool _floatinglabel;
	String _label ='Username';
	String _id;
	String _pattern;
	Map<String,bool> _textfieldClasses;
	Map<String,bool> _inputClasses;
	Map<String,bool> _labelClasses;

    MaterialTextField(@Attribute('floatinglabel') bool floatinglabel){
     //_floatinglabel = floatinglabel;
     _floatinglabel = true;
    _textfieldClasses =  {'mdl-textfield':true,'mdl-js-textfield':true,'mdl-textfield--floating-label':_floatinglabel,'is-focused':false};
    _inputClasses = {'mdl-textfield__input':true};
    _labelClasses = {'mdl-textfield__label':true};
    Uuid uuid = new Uuid();
    _id = uuid.v1();
    }
	/// on focus
    void onfocus(){
    _textfieldClasses['is-focused'] = true;
    print('focus');
    }
    // . on blur
    void onblur(){
    _textfieldClasses['is-focused'] = false;
    }

    /// Disable button.
    void disable() {
        _disabled = true;
    }

    /// Enable button.
    void enable() {
        _disabled = false;
    }

    
    void set enabled(final bool _enabled) => _enabled ? enable() : disable();

    Map<String,bool> get textfieldClasses => _textfieldClasses;
    
    Map<String,bool> get inputClasses => _inputClasses;
    
    Map<String,bool> get labelClasses => _labelClasses;
    
    bool get enabled => !_disabled;

    String get label => _label;

    String get id => _id;

    String get pattern => _pattern;

	bool get floatinglabel => _floatinglabel;

    void set label(final String value) {
        if(value != null) {
            _label = value;
        }
    }

	void set id(bool value) { _id = value;}

	void set pattern(bool value) { _pattern = value;}

	void set floatinglabel(bool value) { _floatinglabel = value;}


}


